#include "url.h"

	
int
scheme_char(char c)
{
	return (isalpha(c) || c!=':');
}


int
host_char(char c)
{
	return (isalnum(c) || c == '.' || c == '-');
}


int
path_end(char c)
{
	return (c == '\0' || c == '#' || c == '?' || c == '\n' || c == '\r');
}


int
is_index(char *c)
{
	return(*c=='/' && path_end(*(c+1)));
}

int
url_parse(char* request, struct url *parsed_url)
{
	/*
	 * gemini://a has a length of 10 and is the minimum url I could think
	 * of, a string shorter than 10 chars has no way (that I know of!) of
	 * being a valid url, maybe this should be placed outside of this
	 * function...
	*/
	int len = strlen(request);
	if(len <= 9) return -10;

	int tmpstr_l = 0;
	char *tmpstr = calloc(1025, sizeof(char));
	char *str = request;

	if(tmpstr <= 0) return -1;

	//READ SCHEME
	int i = 0;
	while(i<=len && scheme_char(str[i])){
		tmpstr[i] = str[i];
		tmpstr_l++;
		i++;
	}

	parsed_url->scheme = calloc(tmpstr_l, sizeof(char));
	parsed_url->scheme_len = tmpstr_l;
	memcpy(parsed_url->scheme, tmpstr, tmpstr_l);

	//READ SCHEME DELIMITER
	if(!(str[tmpstr_l]==':'))return -11;
	tmpstr_l++;
	len = len-tmpstr_l;
	str = &str[tmpstr_l];

	for(int j = 0;j<2;j++){
		if(*str != '/')return -12;
		str++;
		len--;
	}
	
	//READ HOST
	i = 0;
	tmpstr_l = 0;
	while(i<=len && host_char(str[i])){
		tmpstr[i] = str[i];
		tmpstr_l++;
		i++;
	}

	parsed_url->host = calloc(tmpstr_l, sizeof(char));
	parsed_url->host_len = tmpstr_l;
	memcpy(parsed_url->host, tmpstr, tmpstr_l);
	len = len-tmpstr_l;
	str = &str[tmpstr_l];

	//READ PATH INTO TMP_STR (yeah I am ignoring the port sue me)
	i = 0;
	tmpstr_l = 0;
	while(i<=len && !path_end(str[i])){
		tmpstr[i] = str[i];
		tmpstr_l++;
		i++;
	}

	//IF TMPSTR_L HAS LENGTH 0 THEN WE ADD A '/' TO SERVE THE INDEX
	if(tmpstr_l == 0){
		tmpstr_l++;
		tmpstr[0] = '/';
	}
	if(tmpstr[0] != '/'){return -13;} //NOT A PATH

	parsed_url->path = calloc(tmpstr_l, sizeof(char));
	parsed_url->path_len = tmpstr_l;
	memcpy(parsed_url->path, tmpstr, tmpstr_l);

	return 0;
}
